<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: /workplace/avs-device-sdk/BluetoothImplementations/BlueZ/include/BlueZ/DBusObject.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_27114e8c504df5f4609f20f7d28eb6fc.html">BluetoothImplementations</a></li><li class="navelem"><a class="el" href="dir_734f87f436384b5f4d3ce6cedeff05c0.html">BlueZ</a></li><li class="navelem"><a class="el" href="dir_dcc26bf29d4b694c2f1fb3cf2aba65ed.html">include</a></li><li class="navelem"><a class="el" href="dir_6061b9c865ef17da7826af8a1f20a075.html">BlueZ</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">DBusObject.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_d_bus_object_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright 2018 Amazon.com, Inc. or its affiliates. All Rights Reserved.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * Licensed under the Apache License, Version 2.0 (the &quot;License&quot;).</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * You may not use this file except in compliance with the License.</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * A copy of the License is located at</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *     http://aws.amazon.com/apache2.0/</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * or in the &quot;license&quot; file accompanying this file. This file is distributed</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * express or implied. See the License for the specific language governing</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * permissions and limitations under the License.</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#ifndef ALEXA_CLIENT_SDK_BLUETOOTHIMPLEMENTATIONS_BLUEZ_INCLUDE_BLUEZ_DBUSOBJECT_H_</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#define ALEXA_CLIENT_SDK_BLUETOOTHIMPLEMENTATIONS_BLUEZ_INCLUDE_BLUEZ_DBUSOBJECT_H_</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &lt;memory&gt;</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;unordered_map&gt;</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_d_bus_object_base_8h.html">BlueZ/DBusObjectBase.h</a>&quot;</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a> {</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="keyword">namespace </span>bluetoothImplementations {</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="keyword">namespace </span>blueZ {</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;</div><div class="line"><a name="l00041"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_object.html">   41</a></span>&#160;<span class="keyword">class </span><a class="code" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_object.html">DBusObject</a> : <span class="keyword">public</span> <a class="code" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_object_base.html">DBusObjectBase</a> {</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    <span class="keyword">virtual</span> <a class="code" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_object.html#abd42a1c0b95812d858471605ff95c2c8">~DBusObject</a>() = <span class="keywordflow">default</span>;</div><div class="line"><a name="l00050"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_object.html#a68ab85d17ddd16b1a77a17b08f36bfd0">   50</a></span>&#160;    <span class="keyword">using</span> <a class="code" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_object.html#a68ab85d17ddd16b1a77a17b08f36bfd0">commandHandler_t</a> = void (T::*)(GVariant* parameters, GDBusMethodInvocation* invocation);</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="keyword">protected</span>:</div><div class="line"><a name="l00062"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_object.html#a0e5f87b77466984cfb2b2951792abc91">   62</a></span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_object.html#a0e5f87b77466984cfb2b2951792abc91">DBusObject</a>(</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;        std::shared_ptr&lt;DBusConnection&gt; connection,</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;        std::string xmlInterfaceIntrospection,</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;        std::string objectPath,</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;        std::unordered_map&lt;std::string, commandHandler_t&gt; methodMap) :</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;            <a class="code" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_object_base.html">DBusObjectBase</a>(connection, xmlInterfaceIntrospection, objectPath, &amp;onMethodCallStatic),</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;            m_commands{methodMap} {</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    }</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span> onMethodCallStatic(</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;        GDBusConnection* conn,</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;        <span class="keyword">const</span> gchar* sender_name,</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        <span class="keyword">const</span> gchar* object_path,</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;        <span class="keyword">const</span> gchar* interface_name,</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;        <span class="keyword">const</span> gchar* method_name,</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;        GVariant* parameters,</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;        GDBusMethodInvocation* invocation,</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;        gpointer data) {</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;        <span class="keyword">auto</span> thisPtr = <span class="keyword">static_cast&lt;</span>T*<span class="keyword">&gt;</span>(data);</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;        thisPtr-&gt;onMethodCall(method_name, parameters, invocation);</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    }</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;    <span class="keywordtype">void</span> onMethodCall(<span class="keyword">const</span> gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation);</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;    <span class="comment">// Map between method names and member functions implementing them</span></div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    std::unordered_map&lt;std::string, commandHandler_t&gt; m_commands;</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;};</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;<span class="keywordtype">void</span> DBusObject&lt;T&gt;::onMethodCall(<span class="keyword">const</span> gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation) {</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;    onMethodCalledInternal(method_name);</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;    <span class="keyword">auto</span> iter = m_commands.find(method_name);</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    <span class="keywordflow">if</span> (iter != m_commands.end()) {</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;        commandHandler_t handler = iter-&gt;second;</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;        (<span class="keyword">static_cast&lt;</span>T*<span class="keyword">&gt;</span>(<span class="keyword">this</span>)-&gt;*handler)(parameters, invocation);</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    } <span class="keywordflow">else</span> {</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;        g_dbus_method_invocation_return_error(</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;            invocation, G_DBUS_ERROR, G_DBUS_ERROR_UNKNOWN_METHOD, <span class="stringliteral">&quot;Unknown method: &quot;</span>);</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;    }</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;}</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;}  <span class="comment">// namespace blueZ</span></div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;}  <span class="comment">// namespace bluetoothImplementations</span></div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;}  <span class="comment">// namespace alexaClientSDK</span></div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;<span class="preprocessor">#endif  // ALEXA_CLIENT_SDK_BLUETOOTHIMPLEMENTATIONS_BLUEZ_INCLUDE_BLUEZ_DBUSOBJECT_H_</span></div><div class="ttc" id="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_object_html_a0e5f87b77466984cfb2b2951792abc91"><div class="ttname"><a href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_object.html#a0e5f87b77466984cfb2b2951792abc91">alexaClientSDK::bluetoothImplementations::blueZ::DBusObject::DBusObject</a></div><div class="ttdeci">DBusObject(std::shared_ptr&lt; DBusConnection &gt; connection, std::string xmlInterfaceIntrospection, std::string objectPath, std::unordered_map&lt; std::string, commandHandler_t &gt; methodMap)</div><div class="ttdef"><b>Definition:</b> DBusObject.h:62</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_object_html_abd42a1c0b95812d858471605ff95c2c8"><div class="ttname"><a href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_object.html#abd42a1c0b95812d858471605ff95c2c8">alexaClientSDK::bluetoothImplementations::blueZ::DBusObject::~DBusObject</a></div><div class="ttdeci">virtual ~DBusObject()=default</div></div>
<div class="ttc" id="_d_bus_object_base_8h_html"><div class="ttname"><a href="_d_bus_object_base_8h.html">DBusObjectBase.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_object_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_object.html">alexaClientSDK::bluetoothImplementations::blueZ::DBusObject</a></div><div class="ttdef"><b>Definition:</b> DBusObject.h:41</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_object_base_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_object_base.html">alexaClientSDK::bluetoothImplementations::blueZ::DBusObjectBase</a></div><div class="ttdef"><b>Definition:</b> DBusObjectBase.h:31</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_html"><div class="ttname"><a href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></div><div class="ttdoc">Whether or not curl logs should be emitted. </div><div class="ttdef"><b>Definition:</b> AVSConnectionManager.h:37</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_object_html_a68ab85d17ddd16b1a77a17b08f36bfd0"><div class="ttname"><a href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_d_bus_object.html#a68ab85d17ddd16b1a77a17b08f36bfd0">alexaClientSDK::bluetoothImplementations::blueZ::DBusObject&lt; MediaEndpoint &gt;::commandHandler_t</a></div><div class="ttdeci">void(MediaEndpoint ::*)(GVariant *parameters, GDBusMethodInvocation *invocation) commandHandler_t</div><div class="ttdef"><b>Definition:</b> DBusObject.h:50</div></div>
</div><!-- fragment --></div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
